/*********************************************************************************/

byte *ImgBasic::doGaussMultires24(byte *pic24, int ncol, int nfil, int minlevel,
                                   int maxlevel,int umbral_grad, float reclass, int minlen,
                                   int seguimiento, int debug )
/* EN LAS BANDERAS GUARDO A!L PRINCIPIO LA CARACTERISRICA + - =, Y  */
/* LUEGO LAS COORDENADAS DEL PUNTO DETECTADO EN LA ESCALA MAS BAJA.*/
/* MAX_LEVEL ha de ser menor o igual a 7 */
/* maxlevel ha de ser menor que MAX_LEVEL (tpico entre 3 y 6 ) */
{
 int   contador;
 float *auxiliar;
 float *mod_grad;
 byte  *colorComponent;
 char mensaje[128];

 ProgressMeter(maxlevel+3, 0, 0, "Multirresolucin gausiana");

 /* Iniciacin dimensiones */
 columnas = ncol;
 filas = nfil;

 
 /* BUSCA LA MEMORIA NECESARIA */
 gradtita[0]=NULL;
 supresi[0]=NULL;
 auxiliar=busca_memoria_Float(filas*columnas);
 if (!auxiliar) return NULL;
 mod_grad=busca_memoria_Float(filas*columnas);
 if (!mod_grad) {
   free(auxiliar);
   return NULL;
 }
 colorComponent=busca_memoria(filas*columnas);
 if (!colorComponent) {
   free(auxiliar);
   free(mod_grad);
   return NULL;
 }

 for ( contador=1 ; contador<=maxlevel ; contador++ )
   {
    gradtita[contador]=busca_memoria(filas*columnas);
    if (!gradtita[contador]) {
        for(;contador--;) free(gradtita[contador]);
        free(auxiliar);
        free(mod_grad);
        free(colorComponent);
        TRACE("Fallo requiriendo memoria en BEDEC");
        return NULL;
    }
    supresi[contador]= busca_memoria ( (long)filas*(long)columnas );
    if (!supresi[contador]) {
       // Fallo requiriendo memoria
       free(gradtita[contador]);          
       for (; contador-- ;) {
          free(supresi[contador]);
          free(gradtita[contador]);
       }
       free(auxiliar);
       free(mod_grad);
       free(colorComponent);
       return NULL;
    }
   }
 TRACE("Fin de busqueda de memoria\n");
 

 /* RELLENO CON LA 1 DERIVADA DE LA IMAGEN Y LA 1 DERIVADA DE LAS   */
 /* GAUSIANAS DE LA ORIGINAL CON UNA SIGMA DE 0.6, 1.2, 2.4, 4.8, 9.6 */
 float escala;
 for ( contador=1 ; contador<=maxlevel ; contador++ ) {
    
    memset((byte*)mod_grad,0,filas*columnas*sizeof(float));

    TRACE("SUAVIZADO ESCALA %d\n",contador);
    RedComponent(colorComponent, pic24);
    if (contador==1)
      ConvByteToFloat(colorComponent,auxiliar,columnas,filas);
    else
      suavizado_gausiana_32(colorComponent,auxiliar,columnas,filas,(float)sigma[contador]);
    gradiente_32_component(auxiliar,mod_grad,gradtita[contador],
                   factor_gaus(contador-1),
                   (char) ((contador==2) ? 'C' : (contador==3) ? 'D' : 'A'),
                   columnas,filas,NO_UMBRALIZA);


    GreenComponent(colorComponent, pic24);
    if (contador==1)
      ConvByteToFloat(colorComponent,auxiliar,columnas,filas);
    else
      suavizado_gausiana_32(colorComponent,auxiliar,columnas,filas,(float)sigma[contador]);
    gradiente_32_component(auxiliar,mod_grad,gradtita[contador],
                   factor_gaus(contador-1),
                   (char) ((contador==2) ? 'C' : (contador==3) ? 'D' : 'A'),
                   columnas,filas,NO_UMBRALIZA);


    BlueComponent(colorComponent, pic24);


    if (contador==1)
      ConvByteToFloat(colorComponent,auxiliar,columnas,filas);
    else
      suavizado_gausiana_32(colorComponent,auxiliar,columnas,filas,(float)sigma[contador]);        
    gradiente_32_component(auxiliar,mod_grad,gradtita[contador],
                   factor_gaus(contador-1),
                   (char) ((contador==2) ? 'C' : (contador==3) ? 'D' : 'A'),
                   columnas,filas,NO_UMBRALIZA);

    if (debug) {
      FitFltInByte(mod_grad,supresi[contador], columnas*filas, (float)4);
      sprintf(mensaje,"Gradiente %d (sigma %f)",
              contador,sigma[contador]);       
      ShowImage(supresi[contador],F_GREYSCALE,mensaje);
    }

    TRACE("Supresion de puntos no maximos escala %d\n",contador);
    escala  = MaximumFlt(mod_grad,filas*columnas);
    escala /= (float) 255.49;
    supresion_puntos_32(mod_grad,gradtita[contador],supresi[contador],
		    columnas,filas,escala*umbral_grad*ReduccionRuidoNivel[contador],escala);
            
    if (debug) {
      sprintf(mensaje,"Supresion de puntos\nno maximos %d",contador);
      ShowImage(supresi[contador],F_GREYSCALE,mensaje);
    }
    ProgressMeter(maxlevel+3, -1, contador, "Multirresolucin gausiana");
 }
 TRACE("Fin de gradiente y gausianas\n");
  
 /* Slo necesito auxiliar para guardar la imagen suavizada o 
    la supresion de puntos*/
 free(auxiliar);
 free(mod_grad);
 free(colorComponent);

 /* Con las supresiones a cada nivel, realiza anlisis descendiente */
 return AnalisisDescendente(minlevel,maxlevel, 
   (seguimiento) ? reclass : (float) 0.0, minlen,debug);
}
 
/*********************************************************************************/
  
byte *ImgBasic::doGaussMultiresGrey( byte *picGrey, int ncol, int nfil, int minlevel,
                                     int maxlevel, int umbral_grad, float reclass, int minlen,
                                     int seguimiento, int debug )
/* EN LAS BANDERAS GUARDO A!L PRINCIPIO LA CARACTERISRICA + - =, Y  */
/* LUEGO LAS COORDENADAS DEL PUNTO DETECTADO EN LA ESCALA MAS BAJA.*/
/* MAX_LEVEL ha de ser menor o igual a 7 */
/* maxlevel ha de ser menor que MAX_LEVEL (tpico entre 3 y 6 ) */
{
 int contador;
 float *auxiliar;
 float *mod_grad;
 char mensaje[128];

 ProgressMeter(maxlevel+3, 0, 0, "Multirresolucin gausiana");

 /* Iniciacin dimensiones */
 columnas = ncol;
 filas = nfil;

 /* BUSCA LA MEMORIA NECESARIA */
 gradtita[0]=NULL;
 supresi[0]=NULL;
 auxiliar=busca_memoria_Float(filas*columnas);
 if (!auxiliar) return NULL;
 mod_grad=busca_memoria_Float(filas*columnas);
 if (!mod_grad) {
   free(auxiliar);
   return NULL;
 }
 
 for ( contador=1 ; contador<=maxlevel ; contador++ )
   {
    gradtita[contador]=busca_memoria(filas*columnas);
    if (!gradtita[contador]) {
        for(;contador--;) free(gradtita[contador]);
        free(auxiliar);
        free(mod_grad);
        TRACE("Fallo requiriendo memoria en BEDEC");
        return NULL;
    }
    supresi[contador]= busca_memoria ( (long)filas*(long)columnas );
    if (!supresi[contador]) {
       // Fallo requiriendo memoria
       free(gradtita[contador]);          
       for (; contador-- ;) {
          free(supresi[contador]);
          free(gradtita[contador]);
       }
       free(auxiliar);
       free(mod_grad); 
       return NULL;
    }
   }
 TRACE("Fin de busqueda de memoria\n");
 

 /* RELLENO CON LA 1 DERIVADA DE LA IMAGEN Y LA 1 DERIVADA DE LAS   */
 /* GAUSIANAS DE LA ORIGINAL CON UNA SIGMA DE 0.6, 1.2, 2.4, 4.8, 9.6 */

 float escala;
 for ( contador=1 ; contador<=maxlevel ; contador++ ) {
    
    TRACE("SUAVIZADO ESCALA %d\n",contador);
    if (contador==1)
      ConvByteToFloat(picGrey,auxiliar,columnas,filas);
    else
      suavizado_gausiana_32(picGrey,auxiliar,columnas,filas,
                            (float) sigma[contador]);
    
    if (debug) {
      FitFltInByte(auxiliar,supresi[contador], columnas*filas, (float)4);
      sprintf(mensaje,"Imagen filtrada %d (sigma %f)",
              contador,sigma[contador]);       
      ShowImage(supresi[contador],F_GREYSCALE,mensaje);
    }

    gradiente_32_exp(auxiliar,mod_grad,gradtita[contador],
                   factor_gaus(contador-1),
                   (char) ((contador==2) ? 'C' : (contador==3) ? 'D' : 'A'),
                   columnas,filas,NO_UMBRALIZA);

    if (debug) {
      FitFltInByte(mod_grad,supresi[contador], columnas*filas, (float)4);
      sprintf(mensaje,"Gradiente %d (sigma %f)",
              contador,sigma[contador]);       
      ShowImage(supresi[contador],F_GREYSCALE,mensaje);
    }

    TRACE("Supresion de puntos no maximos escala %d\n",contador);
    escala  = MaximumFlt(mod_grad,filas*columnas);
    escala /= (float) 255.49;
    supresion_puntos_32(mod_grad,gradtita[contador],supresi[contador],
		    columnas,filas,escala*umbral_grad*ReduccionRuidoNivel[contador],escala);
  
    if (debug) {
      sprintf(mensaje,"supresion de puntos\nno maximos %d",contador);
      ShowImage(supresi[contador],F_GREYSCALE,mensaje);
    }    
    ProgressMeter(maxlevel+3, -1, contador, "Multirresolucin gausiana");
 }
 TRACE("Fin de gradiente y gausianas\n");
  
 /* Slo necesito auxiliar para guardar la imagen suavizada o 
    la supresion de puntos*/
 free(auxiliar);
 free(mod_grad);

 /* Con las supresiones a cada nivel, realiza anlisis descendiente */
 return AnalisisDescendente(minlevel,maxlevel, 
   (seguimiento) ? reclass : (float) 0.0, minlen,debug);
}

