/*********************************************************************************\
*     File:                  R E S I Z E . C P P                                  *
*                                                                                 *
*     Standard   C++                                                              *
*                                                                                 *
\*********************************************************************************/
/*
 * Resize.cpp: algoritms to change image size without cropping (like a zoom)
 *
 *  Contains:
 *         void ResizePic();
 */

#include "ImgBasic.h"


/*********************************************************************************/
void ImgBasic::ResizePic(void)
{
  byte* pic24;
  char buf[128];         /* Buffer for user input                */
  int new_w,new_h;

  /* Ask the value of the parameter to the user                 *
   * Only alow numbers and decimal point: "0123456789x, "       */
  itoa(pWIDE, buf, 10);
  InputDialog("Introduce la nueva anchura de la imagen",
          buf, 64, "0123456789x, ", 1);
  new_w = atoi(buf);

  itoa(pHIGH, buf, 10);
  InputDialog("Introduce la nueva altura de la imagen",
          buf, 64, "0123456789x, ", 1);
  new_h = atoi(buf);
  
  /* Check for right values                                      */
  if ( new_h <= 0 || new_w <= 0 ){
    Error("El formato de los parametros no es correcto");
    return;
  }

  pic24 = Smooth24(pic, picType,
             pWIDE,pHIGH, new_w, new_h, 
             rMap,gMap, bMap);
  if (pic24) {
    StoreNewPic(pic24, PIC24, FALSE, new_w, new_h, 0);
    RedrawPic(); // Display new image
  } else {
    Error("Smooth24 ha fallado");
    return;
  }	
}
/*********************************************************************************/
