/***********************************************************************/
/* VERSIONES ACELERADAS DE LOS ALGORITMOS PARA VISIN ARTIFICIAL                               */
/* (c) Joaqun Mur ( abril 1997) jmur@robot3.cps.unizar.es  */
/***********************************************************************/

#include <string.h>

#define IMPLEMENTATION_MIGUELAN
#include "miguelan.h"
#undef _COMPUTE_MAX_
//#define _COMPUTE_MAX_

/******************************************************************************/
static void SumaFilas(int* suma_filas, int *pt_imagen, int ncol )
{
 int x,y;
 /* Guarda en suma_filas las primeras 4 filas */
 /* Los tres puntos iniciales a la izda */
 x=ncol-1;
 //y=(pt_imagen[x]+pt_imagen[x-1])<<1;
 y=pt_imagen[x]*3+pt_imagen[x-1];
 suma_filas[ncol+2]=suma_filas[ncol+1]=suma_filas[ncol]=suma_filas[x]= y;
 x--; /* x = ncol-2 */
 //y -= pt_imagen[ncol-2];
 y -= pt_imagen[ncol-1];
 y += pt_imagen[x-1];
 suma_filas[x] = y;
 x--; /* x = ncol-3 */
 y -= pt_imagen[ncol-1];
 y += pt_imagen[x-1];
 suma_filas[x] = y;
 x--; /* x = ncol-4 */
 /* Nivel intermedio */
 for ( ; x ; x--) { 
   y -= pt_imagen[x+3];
   y += pt_imagen[x-1];
   suma_filas[x] = y;
  }
 /* Pto final izdo */
 y -= pt_imagen[3];
 y += pt_imagen[0];
 suma_filas[0] = y;
}

/******************************************************************************/
static void SumaColumnas( int*sumaCol, int *filaAntigua,
                    int *filaNueva, int ncol )
{
 int x;
 /* Guarda en suma_filas las primeras 4 filas */
 /* Los tres puntos iniciales a la izda */
 x=ncol-1;
 sumaCol[ncol+2]=sumaCol[ncol+1]=sumaCol[ncol] +=
   filaNueva[x]-filaAntigua[x];
 filaNueva--; filaAntigua--;/* x = ncol-2 */
 /* Nivel intermedio */
 for ( ; x ;x-- ) { 
   sumaCol[x] +=
     filaNueva[x]-filaAntigua[x];
  }
 /* Pto final izdo */
 sumaCol[0]=sumaCol[1];
}

/******************************************************************************/
static void InicializaSumaColumnas(int* sumaCol, int *Imagen, int ncol )
{
 int x;
 /* Los tres puntos iniciales a la izda */
 x=ncol-1;
 sumaCol[ncol+2]=sumaCol[ncol+1]=sumaCol[ncol]=
   Imagen[x]<<2;
 /* x = ncol-2 */
 Imagen--;
 /* Nivel intermedio */
 for ( ; x ; x--) { 
   sumaCol[x] = Imagen[x]<<2;
  }
 /* Pto final izdo */
 sumaCol[0]= Imagen[0]<<2;
}

/******************************************************************************/
void FastGradientGrey4x4 (int *pt_imagen,float *pt_gradientexy,
		                   byte *pt_gradientetita, int ncol,int nfil, int noise_comp)

/* Realiza el gradiente de la imagen pasada como puntero pt_imagen      */
/* IMAGEN GREY */
{
 int gx,maximo /* abs maximo */;                          /* Almacena el valor pasada a x */
 int gy,minimo /* abs minimo */;                          /* Almacena el valor pasada a y */
 int x,y;
 int *suma_filas, *suma_columnas;
 int* tabla_filas[4];
 int ultimaFila, filaNueva, filaAntigua, ncol2;
 #ifdef _COMPUTE_MAX_
        int maximo_total = 0;
 #endif     

 ncol2 = ncol<<1;
 ultimaFila = (nfil-1)*ncol;

 suma_filas = (int*) malloc(16*(ncol+4));
 if (!suma_filas) 
   fprintf(stderr,"Fallo al requerir memoria en FastGradientGrey4x4\n");
 tabla_filas[0]=suma_filas;
 tabla_filas[1]=&suma_filas[ncol+4];
 tabla_filas[2]=&suma_filas[2*(ncol+4)];
 tabla_filas[3]=&suma_filas[3*(ncol+4)];
 /* Calcula las tres primeras filas */
 SumaFilas( tabla_filas[0], &pt_imagen[ultimaFila], ncol);
 memcpy(tabla_filas[1],tabla_filas[0],(ncol+4)*4);
 memcpy(tabla_filas[2],tabla_filas[0],(ncol+4)*4);

 suma_columnas = (int*) malloc(4*(ncol+4));
 if (!suma_columnas) 
   fprintf(stderr,"Fallo al requerir memoria en FastGradientGrey4x4\n");
 InicializaSumaColumnas(suma_columnas, &pt_imagen[ultimaFila], ncol );

  for ( y=nfil*ncol; y ;) {

    /* Calculo de los punteros a fila */
    filaAntigua = y + ncol2;
    if (filaAntigua > ultimaFila) filaAntigua=ultimaFila;
    y -= ncol;
    filaNueva = y-ncol;
    if (filaNueva < 0 ) filaNueva=0;

    { /* intercambio de filas */
      int *aux = tabla_filas[3];
      tabla_filas[3] = tabla_filas[2];
      tabla_filas[2] = tabla_filas[1];
      tabla_filas[1] = tabla_filas[0];
      tabla_filas[0] = aux;
      SumaFilas( aux, &pt_imagen[filaNueva], ncol );
    }

    /* Actualiza suma de columnas */
    SumaColumnas(suma_columnas, &pt_imagen[filaAntigua],
                    &pt_imagen[filaNueva], ncol );
    
    for ( x=ncol; x ; ) {
      x--;
      /* media = tabla_columnas[0][x]+tabla_columnas[0][x+1]
                +tabla_columnas[0][x+2]+tabla_columnas[0][x+3] */
      /* gx= (3*(suma_columnas[x+3] - suma_columnas[x]) +
          suma_columnas[x+2] - suma_columnas[x+1] ) ; */
      gx= suma_columnas[x+3] + suma_columnas[x+2] -
          suma_columnas[x+1] - suma_columnas[x] ;
      maximo= (gx>=0) ? gx : -gx; 
      #ifdef _COMPUTE_MAX_
        if (maximo>maximo_total) maximo_total = maximo;
      #endif     
      /* gy= (3*(tabla_filas[3][x] - tabla_filas[0][x]) +
          tabla_filas[2][x] - tabla_filas[1][x]) ; */
      gy= tabla_filas[3][x] + tabla_filas[2][x] - 
          tabla_filas[1][x] - tabla_filas[0][x] ; 
      minimo= (gy>=0) ? gy : -gy;
      #ifdef _COMPUTE_MAX_
        if (minimo>maximo_total) maximo_total = minimo;
      #endif     

      /* CALCULO NORMAL DEL ARGUMENTO */
      pt_gradientetita[x+y]=FastAtan(gx, maximo, gy, minimo);
  
      /* Mismo clculo ajustado con un polinomio de tercer orden
       * de Taylor centrado en minimo=0 */
      /* MODULO = RAIZ(1+(minimo/MAXIMO)^2) * MAXIMO / RAIZ(2)						
       * Frmula aproximada con un polinomio de taylor de 5 orden
       *         centrado en x=0, (llamo x=minimo/MAXIMO)						
       * MODULO aprx = (1 + 0,5*x^2 - (3/4!)*X^4 )*MAXIMO/RAIZ(2)						
       */
        // factor de escala: 1.5 
       if (maximo /*abs(gx)*/ >= minimo /*abs(gy)*/) {
        pt_gradientexy[x+y] = (maximo)  
          ? ((float)maximo  + (((float)minimo) * ((float)minimo) / (float)(maximo<<1)))
          :  (float) 0 ;
        
       } else { /* intercambio mximo por mnimo */
        pt_gradientexy[x+y] = 
            ((float)minimo  + (((float)maximo) * ((float)maximo) / (float)(minimo<<1))) ;                                
        }

    } /* fin del bucle for ( fin tratamiento de una fila) */
 }  /* fin del fucle for (fin tratamiento de columnas )*/
}     /* fin del prodedimiento FastGradientGrey */

/*********************************************************************************/


/******************************************************************************/
static void SumaFilasRGB(int* suma_filas, int *pt_imagen, int ncol )
{
 int x,y, *ptr = &suma_filas[ncol-1];
 /* Guarda en suma_filas las primeras 4 filas */
 /* Los tres puntos iniciales a la izda */
 x=3*(ncol-1);
 y=pt_imagen[x]*3+pt_imagen[x-3];
 ptr[3]=ptr[2]=ptr[1]=ptr[0]= y;
 x -= 3; /* x = ncol-2 */
 ptr--;
 y -= pt_imagen[x+3];
 y += pt_imagen[x-3];
 *ptr = y;
 x -= 3; /* x = ncol-3 */
 ptr--;
 y -= pt_imagen[3*(ncol-1)];
 y += pt_imagen[x-3];
 *ptr = y;
 x -= 3; /* x = ncol-4 */
 ptr--;
 /* Nivel intermedio */
 for ( ; x ; x -= 3) { 
   y -= pt_imagen[x+9];
   y += pt_imagen[x-3];
   *ptr = y;
   ptr--;
  }
 /* Pto final izdo */
 y -= pt_imagen[9];
 y += pt_imagen[0];
 *ptr = y;
}

/******************************************************************************/
static void SumaColumnasRGB( int*sumaCol, int *filaAntigua,
                    int *filaNueva, int ncol )
{
 int x=3*(ncol-1), *ptr = &sumaCol[ncol];
 /* Guarda en suma_filas las primeras 4 filas */
 /* Los tres puntos iniciales a la izda */
 ptr[2]=ptr[1]=ptr[0]=
   filaNueva[x]-filaAntigua[x];
 ptr--;/* x = ncol-2 */
 /* Nivel intermedio */
 for ( ; x ; ) { 
   x-=3;
   *ptr +=
     filaNueva[x]-filaAntigua[x];
   ptr--;
  }
 /* Pto final izdo */
 ptr[0]=ptr[1];
}

/******************************************************************************/
static void InicializaSumaColumnasRGB(int* sumaCol, int *Imagen, int ncol )
{
 int x,*ptr = &sumaCol[ncol];
 /* Los tres puntos iniciales a la izda */
 Imagen +=3*(ncol-1);
 ptr[2]=ptr[1]=ptr[0]=
   (*Imagen)<<2; 
 ptr--; /* x = ncol-1 */
 /* Nivel intermedio */
 for ( x=ncol-1; x ; x--) { 
   Imagen-=3;
   *ptr = (*Imagen)<<2;
   ptr--;
  }
 /* Pto final izdo */
 ptr[0]=ptr[1];
}

/******************************************************************************/

void FastGradient24_4x4 (int *pt_imagen, float *pt_gradientexy,
		                 byte  *pt_gradientetita, int ncol,int nfil, int noise_comp)

/* Realiza el gradiente de la imagen pasada como puntero pt_imagen      */
/* IMAGEN RGB */
{
 int gx,maximo /* abs maximo */;                          /* Almacena el valor pasada a x */
 int gy,minimo /* abs minimo */;                          /* Almacena el valor pasada a y */
 int x,y;
 int *suma_red, *suma_green, *suma_blue;
 int *col_red, *col_green, *col_blue;
 int *tabla_red[4], *tabla_green[4], *tabla_blue[4];
 int ultimaFila, filaNueva, filaAntigua, ncol2, ncol3;
 #ifdef _COMPUTE_MAX_
        int maximo_total = 0;
 #endif     

 ncol2 = ncol<<1;
 ncol3 = ncol*3;
 ultimaFila = 3*(nfil-1)*ncol;

 /* F I L A S */
 /*rojo*/
 suma_red = (int*) malloc(16*(ncol+4));
 if (!suma_red) 
   fprintf(stderr,"Fallo al requerir memoria en FastGradientGrey4x4\n");
 tabla_red[0]=suma_red;
 tabla_red[1]=&suma_red[ncol+4];
 tabla_red[2]=&suma_red[2*(ncol+4)];
 tabla_red[3]=&suma_red[3*(ncol+4)];
 /* Calcula las tres primeras filas */
 SumaFilasRGB( tabla_red[0], &pt_imagen[ultimaFila], ncol );
 memcpy(tabla_red[1],tabla_red[0],(ncol+4)*4);
 memcpy(tabla_red[2],tabla_red[0],(ncol+4)*4);

 /*verde*/
 suma_green = (int*) malloc(16*(ncol+4));
 if (!suma_green) 
   fprintf(stderr,"Fallo al requerir memoria en FastGradientGrey4x4\n");
 tabla_green[0]=suma_green;
 tabla_green[1]=&suma_green[ncol+4];
 tabla_green[2]=&suma_green[2*(ncol+4)];
 tabla_green[3]=&suma_green[3*(ncol+4)];
 /* Calcula las tres primeras filas */
 SumaFilasRGB( tabla_green[0], &pt_imagen[ultimaFila+1], ncol );
 memcpy(tabla_green[1],tabla_green[0],(ncol+4)*4);
 memcpy(tabla_green[2],tabla_green[0],(ncol+4)*4);

 /*azul*/
 suma_blue = (int*) malloc(16*(ncol+4));
 if (!suma_blue) 
   fprintf(stderr,"Fallo al requerir memoria en FastGradientGrey4x4\n");
 tabla_blue[0]=suma_blue;
 tabla_blue[1]=&suma_blue[ncol+4];
 tabla_blue[2]=&suma_blue[2*(ncol+4)];
 tabla_blue[3]=&suma_blue[3*(ncol+4)];
 /* Calcula las tres primeras filas */
 SumaFilasRGB( tabla_blue[0], &pt_imagen[ultimaFila+2], ncol );
 memcpy(tabla_blue[1],tabla_blue[0],(ncol+4)*4);
 memcpy(tabla_blue[2],tabla_blue[0],(ncol+4)*4);


 /* C O L U M N A S */
 /*rojo*/
 col_red = (int*) malloc(4*(ncol+4));
 if (!col_red) 
   fprintf(stderr,"Fallo al requerir memoria en FastGradientGrey4x4\n");
 InicializaSumaColumnasRGB(col_red, &pt_imagen[ultimaFila], ncol );
 /*verde*/
 col_green = (int*) malloc(4*(ncol+4));
 if (!col_green) 
   fprintf(stderr,"Fallo al requerir memoria en FastGradientGrey4x4\n");
 InicializaSumaColumnasRGB(col_green, &pt_imagen[ultimaFila+1], ncol );
 /*azul*/
 col_blue = (int*) malloc(4*(ncol+4));
 if (!col_blue) 
   fprintf(stderr,"Fallo al requerir memoria en FastGradientGrey4x4\n");
 InicializaSumaColumnasRGB(col_blue, &pt_imagen[ultimaFila+2], ncol );

  for ( y=nfil*ncol; y ;) {

    /* Calculo de los punteros a fila */
    filaAntigua = 3*(y + ncol2);
    if (filaAntigua > ultimaFila) filaAntigua=ultimaFila;
    y -= ncol;
    filaNueva = 3*(y-ncol);
    if (filaNueva < 0 ) filaNueva=0;

    { /* intercambio de filas */
      /*rojo*/
      int *aux = tabla_red[3];
      tabla_red[3] = tabla_red[2];
      tabla_red[2] = tabla_red[1];
      tabla_red[1] = tabla_red[0];
      tabla_red[0] = aux;
      SumaFilasRGB( aux, &pt_imagen[filaNueva], ncol );
      /*verde*/
      aux = tabla_green[3];
      tabla_green[3] = tabla_green[2];
      tabla_green[2] = tabla_green[1];
      tabla_green[1] = tabla_green[0];
      tabla_green[0] = aux;
      SumaFilasRGB( aux, &pt_imagen[filaNueva+1], ncol );
      /*azul*/
      aux = tabla_blue[3];
      tabla_blue[3] = tabla_blue[2];
      tabla_blue[2] = tabla_blue[1];
      tabla_blue[1] = tabla_blue[0];
      tabla_blue[0] = aux;
      SumaFilasRGB( aux, &pt_imagen[filaNueva+2], ncol );
    }

    /* Actualiza suma de columnas */
    SumaColumnasRGB(col_red, &pt_imagen[filaAntigua],
                    &pt_imagen[filaNueva], ncol );
    SumaColumnasRGB(col_green, &pt_imagen[filaAntigua+1],
                    &pt_imagen[filaNueva+1], ncol );
    SumaColumnasRGB(col_blue, &pt_imagen[filaAntigua+2],
                    &pt_imagen[filaNueva+2], ncol );
    
    for ( x=ncol; x ; ) {
      int gr,gg,gb;
      x--;
      gr= col_red[x+3] + col_red[x+2] -
          col_red[x+1] - col_red[x] ;
      gg= col_green[x+3] + col_green[x+2] -
          col_green[x+1] - col_green[x] ;
      gb= col_blue[x+3] + col_blue[x+2] -
          col_blue[x+1] - col_blue[x] ;
      maximo= MONO(abs(gr),abs(gg),abs(gb));
      gx= (MONO(gr,gg,gb)>=0) ? maximo : -maximo; 
      #ifdef _COMPUTE_MAX_
        if (maximo>maximo_total) maximo_total = maximo;
      #endif     
      gr= tabla_red[3][x] + tabla_red[2][x] - 
          tabla_red[1][x] - tabla_red[0][x] ; 
      gg= tabla_green[3][x] + tabla_green[2][x] - 
          tabla_green[1][x] - tabla_green[0][x] ; 
      gb= tabla_blue[3][x] + tabla_blue[2][x] - 
          tabla_blue[1][x] - tabla_blue[0][x] ; 
      minimo= MONO(abs(gr),abs(gg),abs(gb));
      gy= (MONO(gr,gg,gb)>=0) ? minimo : -minimo; 
      #ifdef _COMPUTE_MAX_
        if (minimo>maximo_total) maximo_total = minimo;
      #endif     

      /* CALCULO NORMAL DEL ARGUMENTO */
      pt_gradientetita[x+y]=FastAtan(gx, maximo, gy, minimo);
  
      /* Mismo clculo ajustado con un polinomio de tercer orden
       * de Taylor centrado en minimo=0 */
      /* MODULO = RAIZ(1+(minimo/MAXIMO)^2) * MAXIMO / RAIZ(2)						
       * Frmula aproximada con un polinomio de taylor de 5 orden
       *         centrado en x=0, (llamo x=minimo/MAXIMO)						
       * MODULO aprx = (1 + 0,5*x^2 - (3/4!)*X^4 )*MAXIMO/RAIZ(2)						
       */
        // factor de escala: 1.5 
       if (maximo /*abs(gx)*/ >= minimo /*abs(gy)*/) {
        pt_gradientexy[x+y] = (maximo)  
          ? ((float)maximo  + (((float)minimo) * ((float)minimo) / (float)(maximo<<1)))
          :  (float) 0 ;
        
       } else { /* intercambio mximo por mnimo */
        pt_gradientexy[x+y] = 
            ((float)minimo  + (((float)maximo) * ((float)maximo) / (float)(minimo<<1))) ;                                
        }

    } /* fin del bucle for ( fin tratamiento de una fila) */
 }  /* fin del fucle for (fin tratamiento de columnas )*/
}     /* fin del prodedimiento FastGradient24_4x4 */

