/*=====================================================================*/
/*                RUTINA DISENADA POR MIGUEL ANGEL MARTINEZ            */
/*=====================================================================*/

/***********************************************************************/
/* Modificado por Joaqun Mur ( abril 1997) jmur@robot3.cps.unizar.es  */
/***********************************************************************/

#define IMPLEMENTATION_MIGUELAN  
#include "miguelan.h"

/* Algoritmo para perturbar con ruido gausiano una imagen.             */
/* Parmetros: imagen original (tamao filas*columnas), imagen final   */
/*            (con ruido aadido), relacion seal/ruido en dB,         */
/*            nmero de filas, nmero de columnas.                     */
void ensucia(unsigned char *picture,unsigned char *solucion,float snr,
	     int columnas,int filas);

/* Declaracin de funciones privadas de este mdulo                    */

/* Ruido gausiano */
double gaussian();

/* Devuelve un nmero aleatorio normalizado en el rango 0 a 1 */
double uniform();

/* Calcula la varianza de una matriz de puntos (tipo byte) de dimensin */
/* filas * columnas                                                     */
float variance (unsigned char *data,int columnas,int filas);

/*=====================================================================*/
/*  Cuerpo de la implementacin                                        */
/*=====================================================================*/
double uniform()
{
 return((double)rand()/RAND_MAX-0.5);
}


float variance (unsigned char *data,int columnas,int filas)
{
 long i=0;
 float ave,val;
 float sum=(float)0.0;
 float sum2=(float)0.0;

 for( ; i<(long)filas*(long)columnas ; i++ )
    {
     val=(float) data[i];
     sum  += val;
     sum2 += val*val;
    }
 ave=sum/((float)filas*(float)columnas);
 return ((sum2-sum*ave)/((float)filas*(float)columnas-1));
}


double gaussian()
{
 static int ready = 0;
 static double gstore;
 double v1,v2,r,fac,gaus;
 double uniform();

 if(ready==0) {
    do {
       v1=2.0*uniform();
       v2=2.0*uniform();
       r=v1*v1+v2*v2;
    } while (r>1.0);

    fac=sqrt(-2.0*log(r)/r);
    gstore=v1*fac;
    gaus=v2*fac;
    ready=1;
 } else {
    ready = 0;
    gaus = gstore;
 }
 return (gaus);
}


void ensucia(unsigned char *picture,unsigned char *solucion,float snr,
	     int columnas,int filas)
{
 long contador;
 float var_in,nmult;
 int new_valor;
 var_in=(float)sqrt(variance(picture,columnas,filas));
 nmult=(float)(var_in/pow(10,(snr/20.0)));
 for (contador=0;contador<(long)filas*(long)columnas;contador++)
   {
     new_valor=*(picture+contador)+ROUND(nmult*gaussian());
     *(solucion+contador)=  (new_valor > 255) ? 255 :
                          ( (new_valor < 0  ) ?   0 : new_valor );                                  
   }
}