// mainfrm.h : interface of the CMainFrame class

#ifndef _MAINFRAME_H_
#define _MAINFRAME_H_

// To access to CToolBar and CStatusBar
#ifndef __AFXEXT_H__
#include <afxext.h>         
#endif

#include "MeterBar.h"

#define PROG_TIMER  1

class CMainFrame : public CMDIFrameWnd
{
public:
	CMainFrame();
	virtual ~CMainFrame();

protected: // create from serialization only
	BOOL m_bMenuSelected;
	int  m_cxPaneWidth;
	UINT m_nPaneStyle;
	UINT m_nPaneID;

  DECLARE_DYNAMIC(CMainFrame)

// Implementation
private:
  BOOL LoadWindowPlacement(LPWINDOWPLACEMENT pwp);
	void SaveWindowPlacement(LPWINDOWPLACEMENT pwp);


protected:  // control bar embedded members
	CToolBar    m_wndMainframeToolBar;
  CToolBar    m_wndDibToolBar;
  CToolBar    m_wndImgToolBar;
  CToolBar    m_wndInspToolBar;
public:
 	CMeterBar   m_wndStatusBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
  afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnPaletteChanged(CWnd* pFocusWnd);
	afx_msg BOOL OnQueryNewPalette();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnAyudaContenido();
	afx_msg void OnAyudaMostrar();
 	afx_msg void OnDibOpen();
	afx_msg void OnImgOpen();
	afx_msg void OnInspOpen();
	afx_msg void OnClose();
	afx_msg void OnToolbarMain();
	afx_msg void OnUpdateToolbarMain(CCmdUI* pCmdUI);
	afx_msg void OnToolbarDib();
	afx_msg void OnUpdateToolbarDib(CCmdUI* pCmdUI);
	afx_msg void OnToolbarImg();
	afx_msg void OnUpdateToolbarImg(CCmdUI* pCmdUI);
	afx_msg void OnToolbarInsp();
	afx_msg void OnUpdateToolbarInsp(CCmdUI* pCmdUI);
	afx_msg void OnMenuSelect(UINT nItemID, UINT nFlags, HMENU hSysMenu);
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnCapture();
	afx_msg void OnCaptureSettings();
  afx_msg LRESULT OnEndCapture(WPARAM wParam, LPARAM lParam);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
#endif //#ifdef _MAINFRAME_H_
