// CanyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "..\\res\\resource.h"
#include "..\ImgBasic\ImgBasic.h"
#include "ImgDoc.h"
#include "MResDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// static inizalitation

static int     max_level=3;
static int     min_level=3;
static int     threshold=10;
static int     noise_level=2;
static float   reclasificacion=(float) 0.3;
static int     min_len=20;
static int     min_len_noise=3;
static int     holg_ang = 26;
static int     orden=ORDEN_DESCENDENTE ;
static int     desplazamiento = 1;
static BOOL    pasoApaso=FALSE;
static BOOL    bExpand=FALSE;
static int  noise_comp=0;

/////////////////////////////////////////////////////////////////////////////
// CMResDlg static inizalitation

int           CMResDlg::seguimiento=SEGUIMIENTO_NINGUNO ;

/////////////////////////////////////////////////////////////////////////////
// CMResDlg dialog


CMResDlg::CMResDlg( int algType, CWnd* pParent /*=NULL*/)
	: CDialog(CMResDlg::IDD, pParent),
  algoritm_type(algType),
  m_Seguimiento(seguimiento),
  m_PasoApaso(pasoApaso)
{
	//{{AFX_DATA_INIT(CMResDlg)
		// NOTE: the ClassWizard will add member initialization here
 	
	//}}AFX_DATA_INIT
}

BOOL CMResDlg::OnInitDialog() 
{
    CString Str;
    CSliderCtrl* pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_THERESHOLD);
    pSlider->SetRange(0, 50);
    pSlider->SetPos(threshold);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_THRESHOLD, Str);
 
    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_MAX_LEVEL);
    pSlider->SetRange(2, 6);
    pSlider->SetPos(max_level);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_MAX, Str);

    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_MIN_LEVEL);
    pSlider->SetRange(2, 6);
    pSlider->SetPos(min_level);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_MIN, Str);

     pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_RECLASIFICACION);
    pSlider->SetRange(0, 100);
    pSlider->SetPos((int)(reclasificacion*100.0));
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_RECALI, Str);

     pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_MIN_LEN);
    pSlider->SetRange(0, 25);
    pSlider->SetPos(min_len);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_MIN_LEN, Str);

    switch (algoritm_type) {
    case ALG_MULTIRES:
      GetDlgItem (IDC_THERESHOLD_ANGLE)->ShowWindow(SW_HIDE);
      break;
    case ALG_FASTMRES:
      break;
    case ALG_CANYMRES:
      GetDlgItem (IDC_THERESHOLD_NONE)->ShowWindow(SW_HIDE);
      GetDlgItem (IDC_THERESHOLD_CONTIGUOS)->ShowWindow(SW_HIDE);
      GetDlgItem (IDC_THERESHOLD_ANGLE)->ShowWindow(SW_HIDE);
      GetDlgItem (IDC_STATIC_SEG3)->ShowWindow(SW_HIDE);
      seguimiento=1;
      break;
    }
    return CDialog::OnInitDialog();
}

void CMResDlg::DoDataExchange(CDataExchange* pDX)
{ 
  /* if (pDX->m_bSaveAndValidate)==FALSE
   * Uptate local variables with persistent ones
   * and update dialog controls */

  if (!(pDX->m_bSaveAndValidate)) {
    m_Seguimiento=seguimiento;
    m_PasoApaso=pasoApaso;

    /* Enable/disable controls */
     switch (seguimiento) {
     case SEGUIMIENTO_NINGUNO: OnNoSeguimiento(); break;
     case SEGUIMIENTO_CONTINUIDAD: OnSegConti(); break;
     case SEGUIMIENTO_DIRECCION: OnSegDirec(); break;
     }

     ((CSliderCtrl*) GetDlgItem(IDC_THERESHOLD))
             ->SetPos(threshold);

     ((CSliderCtrl*) GetDlgItem(IDC_MAX_LEVEL))
             ->SetPos(max_level);

     ((CSliderCtrl*) GetDlgItem(IDC_MIN_LEVEL))
             ->SetPos(min_level);

     ((CSliderCtrl*) GetDlgItem(IDC_RECLASIFICACION))
             ->SetPos((int)(reclasificacion*100.0));
  
      ((CSliderCtrl*) GetDlgItem(IDC_MIN_LEN))
             ->SetPos(min_len);
    }

  CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CMResDlg)
    DDX_Radio(pDX, IDC_THERESHOLD_NONE,m_Seguimiento);
    DDX_Check(pDX, IDC_PASO_A_PASO, m_PasoApaso);
	//}}AFX_DATA_MAP
    
  /* if (pDX->m_bSaveAndValidate)==TRUE
   * Uptate static variables with dialog values
   * For example, when OK button is pressed
   */

     if (pDX->m_bSaveAndValidate) {
      /* Disable/enable controls depending on radio buttons */
      switch (m_Seguimiento) {
      case SEGUIMIENTO_NINGUNO: OnNoSeguimiento(); break;
      case SEGUIMIENTO_CONTINUIDAD: OnSegConti(); break;
      case SEGUIMIENTO_DIRECCION: OnSegDirec(); break;
      }

      pasoApaso=m_PasoApaso;

     threshold =
     ((CSliderCtrl*) GetDlgItem(IDC_THERESHOLD))
             ->GetPos();

     max_level =
     ((CSliderCtrl*) GetDlgItem(IDC_MAX_LEVEL))
             ->GetPos();

     min_level =
     ((CSliderCtrl*) GetDlgItem(IDC_MIN_LEVEL))
             ->GetPos();

     reclasificacion = (float)
     (((CSliderCtrl*) GetDlgItem(IDC_RECLASIFICACION))
             ->GetPos()) / (float) 100.0;

     min_len =
      ((CSliderCtrl*) GetDlgItem(IDC_MIN_LEN))
             ->GetPos();
     } 
}

BEGIN_MESSAGE_MAP(CMResDlg, CDialog)
	//{{AFX_MSG_MAP(CMResDlg)
	ON_BN_CLICKED(IDC_HELP_CANY, OnHelp)
  ON_BN_CLICKED(IDC_THERESHOLD_NONE,OnNoSeguimiento)
	ON_BN_CLICKED(IDC_THERESHOLD_CONTIGUOS,OnSegConti)
  ON_BN_CLICKED(IDC_THERESHOLD_ANGLE,OnSegDirec)
	ON_WM_HSCROLL()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMResDlg message handlers


void CMResDlg::OnHelp() 
{
	// TODO: Add your control notification handler code here
  MessageBox("La ayuda no est todava a punto","Ayuda");
}

void CMResDlg::OnNoSeguimiento() 
{
	// TODO: Add your control notification handler code here
  seguimiento=m_Seguimiento= SEGUIMIENTO_NINGUNO;
  GetDlgItem (IDC_STATIC_SEG)->EnableWindow(FALSE);
  GetDlgItem (IDC_STATIC_SEG2)->EnableWindow(FALSE);
  GetDlgItem (IDC_STATIC_RECALI)->EnableWindow(FALSE);
  GetDlgItem (IDC_STATIC_MIN_LEN)->EnableWindow(FALSE);
  GetDlgItem (IDC_RECLASIFICACION)->EnableWindow(FALSE);
  GetDlgItem (IDC_MIN_LEN)->EnableWindow(FALSE);
}

void CMResDlg::OnSegConti() 
{
	// TODO: Add your control notification handler code here
  seguimiento=m_Seguimiento= SEGUIMIENTO_CONTINUIDAD;
  GetDlgItem (IDC_STATIC_SEG)->EnableWindow(TRUE);
  GetDlgItem (IDC_STATIC_SEG2)->EnableWindow(TRUE);
  GetDlgItem (IDC_STATIC_RECALI)->EnableWindow(TRUE);
  GetDlgItem (IDC_STATIC_MIN_LEN)->EnableWindow(TRUE);
  GetDlgItem (IDC_RECLASIFICACION)->EnableWindow(TRUE);
  GetDlgItem (IDC_MIN_LEN)->EnableWindow(TRUE);
}

void CMResDlg::OnSegDirec() 
{
	// TODO: Add your control notification handler code here
 seguimiento=m_Seguimiento= SEGUIMIENTO_DIRECCION;
  GetDlgItem (IDC_STATIC_SEG)->EnableWindow(TRUE);
  GetDlgItem (IDC_STATIC_SEG2)->EnableWindow(TRUE);
  GetDlgItem (IDC_STATIC_RECALI)->EnableWindow(TRUE);
  GetDlgItem (IDC_STATIC_MIN_LEN)->EnableWindow(TRUE);
  GetDlgItem (IDC_RECLASIFICACION)->EnableWindow(TRUE);
  GetDlgItem (IDC_MIN_LEN)->EnableWindow(TRUE);
}


void CMResDlg::OnHScroll(UINT nSBCode, UINT nPos,
                             CScrollBar* pScrollBar) 
{
    CSliderCtrl* pSlide = (CSliderCtrl*) pScrollBar;
    
    CString strText;
     strText.Format("%d", pSlide->GetPos());
    // five trackbars are sending
    //  HSCROLL messages (different processing)

   switch(pScrollBar->GetDlgCtrlID()) {
    case IDC_THERESHOLD:
        SetDlgItemText(IDC_STATIC_THRESHOLD, strText);
        break;
    case IDC_MAX_LEVEL:
      SetDlgItemText(IDC_STATIC_MAX, strText);
      //if  (pSlide->GetPos()<6) OnNoSeguimiento();
        {
          CSliderCtrl* pMin =    (CSliderCtrl*) GetDlgItem (IDC_MIN_LEVEL);
          if (pSlide->GetPos() < pMin->GetPos() ) {
             pMin->SetPos(pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_MIN, strText);
          }
        }
      break;
    case IDC_MIN_LEVEL:
      SetDlgItemText(IDC_STATIC_MIN, strText);
      //if  (pSlide->GetPos()>3) OnNoSeguimiento();
        {
          CSliderCtrl* pMax =    (CSliderCtrl*) GetDlgItem (IDC_MAX_LEVEL);
          if ( pSlide->GetPos() > pMax->GetPos()) {
             pMax->SetPos(pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_MAX, strText);
          }
        }
      break;
    case IDC_RECLASIFICACION:
      SetDlgItemText(IDC_STATIC_RECALI, strText);
      break;
    case IDC_MIN_LEN:
        SetDlgItemText(IDC_STATIC_MIN_LEN, strText);
        break;
    }
}

/*********************************************************************************/
/////////////////////////////////////////////////////////////////////////////
// CCannyMresDlg dialog


CCannyMresDlg::CCannyMresDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCannyMresDlg::IDD, pParent),
    m_OrdenCasamiento(orden),
    m_PasoApaso(pasoApaso),
    m_Desplazamiento(desplazamiento)
{
	//{{AFX_DATA_INIT(CCannyMresDlg)
	//}}AFX_DATA_INIT
}

BOOL CCannyMresDlg::OnInitDialog() 
{
    CString Str;

    CSliderCtrl* pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_MAX_LEVEL);
    pSlider->SetRange(2, 6);
    pSlider->SetPos(max_level);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_MAX, Str);

    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_MIN_LEVEL);
    pSlider->SetRange(2, 6);
    pSlider->SetPos(min_level);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_MIN, Str);

    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_THERESHOLD);
    pSlider->SetRange(0, 100);
    pSlider->SetPos(threshold);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_THRESHOLD, Str);
 
    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_THERESHOLD2);
    pSlider->SetRange(0, 20);
    pSlider->SetPos(noise_level);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_THRESHOLD2, Str);

    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_RECLASIFICACION);
    pSlider->SetRange(0, 100);
    pSlider->SetPos((int)(reclasificacion*100.0));
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_RECALI, Str);

    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_MIN_LEN);
    pSlider->SetRange(0, 100);
    pSlider->SetPos(min_len);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_MIN_LEN, Str);

    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_MIN_LEN2);
    pSlider->SetRange(0, 20);
    pSlider->SetPos(min_len_noise);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_MIN_LEN2, Str);

    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_HOLG_ANG);
    pSlider->SetRange(0, 64);
    pSlider->SetPos(holg_ang);
    Str.Format("%3.1f", (double) pSlider->GetPos()/0.711111);
    SetDlgItemText(IDC_STATIC_HOLG_ANG, Str);

    int result = CDialog::OnInitDialog();

    // Show dialog expanded or contracted
    // after OnInitDialog();
    ExpandDialog();

    return result;
}

void CCannyMresDlg::DoDataExchange(CDataExchange* pDX)
{
   /* if (pDX->m_bSaveAndValidate)==FALSE
   * Uptate local variables with persistent ones
   * and update dialog controls */
  if (!(pDX->m_bSaveAndValidate)) {
     m_OrdenCasamiento=orden;
     m_PasoApaso=pasoApaso;
     m_Desplazamiento=desplazamiento;

     ((CSliderCtrl*) GetDlgItem(IDC_MAX_LEVEL))
             ->SetPos(max_level);

     ((CSliderCtrl*) GetDlgItem(IDC_MIN_LEVEL))
             ->SetPos(min_level);

     ((CSliderCtrl*) GetDlgItem(IDC_THERESHOLD))
             ->SetPos(threshold);

     ((CSliderCtrl*) GetDlgItem(IDC_THERESHOLD2))
         ->SetPos(noise_level);

     ((CSliderCtrl*) GetDlgItem(IDC_RECLASIFICACION))
             ->SetPos((int)(reclasificacion*100.0));
  
     ((CSliderCtrl*) GetDlgItem(IDC_MIN_LEN))
             ->SetPos(min_len);
     
     ((CSliderCtrl*) GetDlgItem(IDC_MIN_LEN2))
             ->SetPos(min_len_noise);
     
     ((CSliderCtrl*) GetDlgItem(IDC_HOLG_ANG))
             ->SetPos( holg_ang );
  }

  CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCannyMresDlg)
    DDX_Radio(pDX, IDC_ASCENDENTE,m_OrdenCasamiento);
    DDX_Radio(pDX, IDC_RADIO1,m_Desplazamiento);
    DDX_Check(pDX, IDC_PASO_A_PASO, m_PasoApaso);
	//}}AFX_DATA_MAP

      /* if (pDX->m_bSaveAndValidate)==TRUE
   * Uptate static variables with dialog values
   * For example, when OK button is pressed
   */

   if (pDX->m_bSaveAndValidate) {

     pasoApaso=m_PasoApaso;
     desplazamiento =m_Desplazamiento;
     orden = m_OrdenCasamiento;

     max_level =
     ((CSliderCtrl*) GetDlgItem(IDC_MAX_LEVEL))
             ->GetPos();

     min_level =
     ((CSliderCtrl*) GetDlgItem(IDC_MIN_LEVEL))
             ->GetPos();

     threshold =
     ((CSliderCtrl*) GetDlgItem(IDC_THERESHOLD))
             ->GetPos();

     noise_level =
     ((CSliderCtrl*) GetDlgItem(IDC_THERESHOLD2))
             ->GetPos();

     reclasificacion = (float)
     (((CSliderCtrl*) GetDlgItem(IDC_RECLASIFICACION))
             ->GetPos()) / (float) 100.0;

     min_len =
      ((CSliderCtrl*) GetDlgItem(IDC_MIN_LEN))
             ->GetPos();

     min_len_noise =
     ((CSliderCtrl*) GetDlgItem(IDC_MIN_LEN2))
             ->GetPos();
     
     holg_ang = (int) ( (double)
     ( (CSliderCtrl*) GetDlgItem(IDC_HOLG_ANG))
             ->GetPos() );
   } 
}

void CCannyMresDlg::OnHScroll(UINT nSBCode, UINT nPos,
                             CScrollBar* pScrollBar) 
{
    CSliderCtrl* pSlide = (CSliderCtrl*) pScrollBar;
    
    CString strText;
    strText.Format("%d", pSlide->GetPos());
    // five trackbars are sending
    //  HSCROLL messages (different processing)

   switch(pScrollBar->GetDlgCtrlID()) {
    case IDC_MAX_LEVEL:
        SetDlgItemText(IDC_STATIC_MAX, strText);
        {
          CSliderCtrl* pMin =    (CSliderCtrl*) GetDlgItem (IDC_MIN_LEVEL);
          if (pSlide->GetPos() < pMin->GetPos() ) {
             pMin->SetPos(pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_MIN, strText);
          }
        }
      break;
    case IDC_MIN_LEVEL:
      SetDlgItemText(IDC_STATIC_MIN, strText);  
      {
          CSliderCtrl* pMax =    (CSliderCtrl*) GetDlgItem (IDC_MAX_LEVEL);
          if (pSlide->GetPos() > pMax->GetPos()) {
             pMax->SetPos(pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_MAX, strText);
          }
        }
      break;
    case IDC_THERESHOLD:
        SetDlgItemText(IDC_STATIC_THRESHOLD, strText);
        {
          CSliderCtrl* pMin =    (CSliderCtrl*) GetDlgItem (IDC_THERESHOLD2);
          if (pSlide->GetPos() < pMin->GetPos() ) {
             pMin->SetPos(pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_THRESHOLD2, strText);
          }
        }
        break;
    case IDC_THERESHOLD2:
        SetDlgItemText(IDC_STATIC_THRESHOLD2, strText);
        {
          CSliderCtrl* pMax =    (CSliderCtrl*) GetDlgItem (IDC_THERESHOLD);
          if ( pSlide->GetPos() > pMax->GetPos()) {
             pMax->SetPos( pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_THRESHOLD, strText);
          }
        }
        break;
    case IDC_RECLASIFICACION:
        SetDlgItemText(IDC_STATIC_RECALI, strText);
        break;
    case IDC_MIN_LEN:
        SetDlgItemText(IDC_STATIC_MIN_LEN, strText);
        {
          CSliderCtrl* pMin =    (CSliderCtrl*) GetDlgItem (IDC_MIN_LEN2);
          if (pSlide->GetPos() < pMin->GetPos() ) {
             pMin->SetPos(pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_MIN_LEN2, strText);
          }
        }
        break;
    case IDC_MIN_LEN2:
        SetDlgItemText(IDC_STATIC_MIN_LEN2, strText);
        {
          CSliderCtrl* pMax =    (CSliderCtrl*) GetDlgItem (IDC_MIN_LEN);
          if ( pSlide->GetPos() > pMax->GetPos()) {
             pMax->SetPos( pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_MIN_LEN, strText);
          }
        }
        break;
    case IDC_HOLG_ANG:
        strText.Format("%3.1f", (double) pSlide->GetPos()/0.711111);
        SetDlgItemText(IDC_STATIC_HOLG_ANG, strText);
        break;
    }
}

void CCannyMresDlg::OnHelp() 
{
	// TODO: Add your control notification handler code here
  MessageBox("La ayuda no est todava a punto","Ayuda");
}


void CCannyMresDlg::OnMore() 
{
	// TODO: Add your control notification handler code here
	// bExpand controla el estado expandido (frente al contrado)
  ExpandDialog ();
  bExpand = !bExpand;
}

void CCannyMresDlg::ExpandDialog ()
{
	// Expand the dialog to full size if bExpand is TRUE; otherwise
	// contract, with the new bottom set to the bottom of the 
	// divider control specified in IDC_DIVIDER.

	static  CRect rcLarge;
	static  CRect rcSmall;
	CString sExpand;

	// First time through, save the dialogs large
	// and small sizes
	if (rcLarge.IsRectNull())
	{
		CRect rcLandmark;
		CWnd* pWndLandmark = GetDlgItem (IDC_DIVIDER);
		ASSERT(pWndLandmark);	
	
		GetWindowRect (rcLarge);
		pWndLandmark->GetWindowRect (rcLandmark);
	
		rcSmall = rcLarge;
		rcSmall.bottom = rcLandmark.top;
	}

	if (bExpand)
	{
		// Expand the dialog: resize the dialog
		// to its original size (rcLarge)
		SetWindowPos(NULL, 0, 0, rcLarge.Width(), rcLarge.Height(),
			SWP_NOMOVE | SWP_NOZORDER);

		sExpand = "<< &Principal";
		EnableVisibleChildren();
	}
	else
	{
		// Contract the dialog to the small size
		SetWindowPos(NULL, 0, 0, rcSmall.Width(), rcSmall.Height(),
			SWP_NOMOVE | SWP_NOZORDER);

		sExpand = "  &Ajuste fino >>";
		EnableVisibleChildren();
	}	
	
	SetDlgItemText (IDC_MORE, sExpand);
}


void CCannyMresDlg::EnableVisibleChildren()
{
	// Disable all children not in the current dialog. This prevents
	// tabbing to hidden controls and disables accelerators.

	// Get the first child control
	CWnd *pWndCtl = GetWindow (GW_CHILD);
	CRect rcTest;
	CRect rcControl;
	CRect rcShow;
	
	GetWindowRect(rcShow);
	   
	while (pWndCtl != NULL)
	{
		pWndCtl->GetWindowRect (rcControl);
		
		if (rcTest.IntersectRect (rcShow, rcControl))
			pWndCtl->EnableWindow(TRUE);
		else
			pWndCtl->EnableWindow(FALSE);
		
		// Get the next sibling window in this chain.
		pWndCtl = pWndCtl->GetWindow (GW_HWNDNEXT);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CCannyMresDlg message handlers
BEGIN_MESSAGE_MAP(CCannyMresDlg, CDialog)
	//{{AFX_MSG_MAP(CCannyMresDlg)
 	ON_BN_CLICKED(IDC_HELP_CANY, OnHelp)
	ON_WM_HSCROLL()
	ON_WM_LBUTTONUP()
	ON_BN_CLICKED(IDC_MORE, OnMore)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/*********************************************************************************/
/////////////////////////////////////////////////////////////////////////////
// CCannyMresDlg dialog

CCannyMresDlg4x4::CCannyMresDlg4x4(CWnd* pParent /*=NULL*/)
  : CDialog(CCannyMresDlg4x4::IDD, pParent),
    m_OrdenCasamiento(orden),
    m_PasoApaso(pasoApaso),
    m_Desplazamiento (desplazamiento)

 {
	//{{AFX_DATA_INIT(CCannyMresDlg4x4)
	//}}AFX_DATA_INIT
}

BOOL CCannyMresDlg4x4::OnInitDialog() 
{
    CString Str;

    CSliderCtrl* pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_MAX_LEVEL);
    pSlider->SetRange(2, 6);
    pSlider->SetPos(max_level);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_MAX, Str);

    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_MIN_LEVEL);
    pSlider->SetRange(2, 6);
    pSlider->SetPos(min_level);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_MIN, Str);

    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_THERESHOLD);
    pSlider->SetRange(0, 100);
    pSlider->SetPos(threshold);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_THRESHOLD, Str);
 
    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_THERESHOLD2);
    pSlider->SetRange(0, 20);
    pSlider->SetPos(noise_level);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_THRESHOLD2, Str);

    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_RECLASIFICACION);
    pSlider->SetRange(0, 100);
    pSlider->SetPos((int)(reclasificacion*100.0));
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_RECALI, Str);

    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_MIN_LEN);
    pSlider->SetRange(0, 100);
    pSlider->SetPos(min_len);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_MIN_LEN, Str);

    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_MIN_LEN2);
    pSlider->SetRange(0, 20);
    pSlider->SetPos(min_len_noise);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_MIN_LEN2, Str);

    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_HOLG_ANG);
    pSlider->SetRange(0, 64);
    pSlider->SetPos(holg_ang);
    Str.Format("%3.1f", (double) pSlider->GetPos()/0.711111);
    SetDlgItemText(IDC_STATIC_HOLG_ANG, Str);

    pSlider =
        (CSliderCtrl*) GetDlgItem(IDC_NOISE_COMP);
    pSlider->SetRange(0, 60);
    pSlider->SetPos(noise_comp);
    Str.Format("%d", pSlider->GetPos());
    SetDlgItemText(IDC_STATIC_NOISE_COMP, Str);
    
    int result = CDialog::OnInitDialog();

    // Show dialog expanded or contracted
    // after OnInitDialog();
    ExpandDialog();

    return result;
}

void CCannyMresDlg4x4::DoDataExchange(CDataExchange* pDX)
{
     /* if (pDX->m_bSaveAndValidate)==FALSE
   * Uptate local variables with persistent ones
   * and update dialog controls */
  if (!(pDX->m_bSaveAndValidate)) {
     m_OrdenCasamiento=orden;
     m_PasoApaso=pasoApaso;
     m_Desplazamiento=desplazamiento;

     ((CSliderCtrl*) GetDlgItem(IDC_NOISE_COMP))
             ->SetPos(noise_comp/5);

     ((CSliderCtrl*) GetDlgItem(IDC_MAX_LEVEL))
             ->SetPos(max_level);

     ((CSliderCtrl*) GetDlgItem(IDC_MIN_LEVEL))
             ->SetPos(min_level);

     ((CSliderCtrl*) GetDlgItem(IDC_THERESHOLD))
             ->SetPos(threshold);

     ((CSliderCtrl*) GetDlgItem(IDC_THERESHOLD2))
         ->SetPos(noise_level);

     ((CSliderCtrl*) GetDlgItem(IDC_RECLASIFICACION))
             ->SetPos((int)(reclasificacion*100.0));
  
     ((CSliderCtrl*) GetDlgItem(IDC_MIN_LEN))
             ->SetPos(min_len);
     
     ((CSliderCtrl*) GetDlgItem(IDC_MIN_LEN2))
             ->SetPos(min_len_noise);
     
     ((CSliderCtrl*) GetDlgItem(IDC_HOLG_ANG))
             ->SetPos( holg_ang );
  }

  CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCannyMresDlg4x4)
    DDX_Radio(pDX, IDC_ASCENDENTE,m_OrdenCasamiento);
    DDX_Radio(pDX, IDC_RADIO1,m_Desplazamiento);
    DDX_Check(pDX, IDC_PASO_A_PASO, m_PasoApaso);
	//}}AFX_DATA_MAP

   /* if (pDX->m_bSaveAndValidate)==TRUE
   * Uptate static variables with dialog values
   * For example, when OK button is pressed
   */

   if (pDX->m_bSaveAndValidate) {

     pasoApaso=m_PasoApaso;
     desplazamiento =m_Desplazamiento;
     orden = m_OrdenCasamiento;

     noise_comp =
     ((CSliderCtrl*) GetDlgItem(IDC_NOISE_COMP))
             ->GetPos() * 5;
     max_level =
     ((CSliderCtrl*) GetDlgItem(IDC_MAX_LEVEL))
             ->GetPos();
     min_level =
     ((CSliderCtrl*) GetDlgItem(IDC_MIN_LEVEL))
             ->GetPos();
     threshold =
     ((CSliderCtrl*) GetDlgItem(IDC_THERESHOLD))
             ->GetPos();
     noise_level =
     ((CSliderCtrl*) GetDlgItem(IDC_THERESHOLD2))
             ->GetPos();

     reclasificacion = (float)
     (((CSliderCtrl*) GetDlgItem(IDC_RECLASIFICACION))
             ->GetPos()) / (float) 100.0;

     min_len =
      ((CSliderCtrl*) GetDlgItem(IDC_MIN_LEN))
             ->GetPos();

     min_len_noise =
     ((CSliderCtrl*) GetDlgItem(IDC_MIN_LEN2))
             ->GetPos();
     
     holg_ang = (int) ( (double)
     ( (CSliderCtrl*) GetDlgItem(IDC_HOLG_ANG))
             ->GetPos() );
   } 
}

void CCannyMresDlg4x4::OnHScroll(UINT nSBCode, UINT nPos,
                             CScrollBar* pScrollBar) 
{
       CSliderCtrl* pSlide = (CSliderCtrl*) pScrollBar;
    
    CString strText;
    strText.Format("%d", pSlide->GetPos());
    // five trackbars are sending
    //  HSCROLL messages (different processing)

   switch(pScrollBar->GetDlgCtrlID()) {
    case IDC_MAX_LEVEL:
        SetDlgItemText(IDC_STATIC_MAX, strText);
        {
          CSliderCtrl* pMin =    (CSliderCtrl*) GetDlgItem (IDC_MIN_LEVEL);
          if (pSlide->GetPos() < pMin->GetPos() ) {
             pMin->SetPos(pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_MIN, strText);
          }
        }
      break;
    case IDC_MIN_LEVEL:
      SetDlgItemText(IDC_STATIC_MIN, strText);  
      {
          CSliderCtrl* pMax =    (CSliderCtrl*) GetDlgItem (IDC_MAX_LEVEL);
          if (pSlide->GetPos() > pMax->GetPos()) {
             pMax->SetPos(pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_MAX, strText);
          }
        }
      break;
    case IDC_THERESHOLD:
        SetDlgItemText(IDC_STATIC_THRESHOLD, strText);
        {
          CSliderCtrl* pMin =    (CSliderCtrl*) GetDlgItem (IDC_THERESHOLD2);
          if (pSlide->GetPos() < pMin->GetPos() ) {
             pMin->SetPos(pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_THRESHOLD2, strText);
          }
        }
        break;
    case IDC_THERESHOLD2:
        SetDlgItemText(IDC_STATIC_THRESHOLD2, strText);
        {
          CSliderCtrl* pMax =    (CSliderCtrl*) GetDlgItem (IDC_THERESHOLD);
          if ( pSlide->GetPos() > pMax->GetPos()) {
             pMax->SetPos( pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_THRESHOLD, strText);
          }
        }
        break;
    case IDC_RECLASIFICACION:
        SetDlgItemText(IDC_STATIC_RECALI, strText);
        break;
    case IDC_MIN_LEN:
        SetDlgItemText(IDC_STATIC_MIN_LEN, strText);
        {
          CSliderCtrl* pMin =    (CSliderCtrl*) GetDlgItem (IDC_MIN_LEN2);
          if (pSlide->GetPos() < pMin->GetPos() ) {
             pMin->SetPos(pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_MIN_LEN2, strText);
          }
        }
        break;
    case IDC_MIN_LEN2:
        SetDlgItemText(IDC_STATIC_MIN_LEN2, strText);
        {
          CSliderCtrl* pMax =    (CSliderCtrl*) GetDlgItem (IDC_MIN_LEN);
          if ( pSlide->GetPos() > pMax->GetPos()) {
             pMax->SetPos( pSlide->GetPos() );
             SetDlgItemText(IDC_STATIC_MIN_LEN, strText);
          }
        }
        break;
    case IDC_HOLG_ANG:
        strText.Format("%3.1f", (double) pSlide->GetPos()/0.711111);
        SetDlgItemText(IDC_STATIC_HOLG_ANG, strText);
        break;
    case IDC_NOISE_COMP:
        strText.Format("%d\%%", pSlide->GetPos()*5);
        SetDlgItemText(IDC_STATIC_NOISE_COMP, strText);
        break;
    }
}

void CCannyMresDlg4x4::OnHelp() 
{
	// TODO: Add your control notification handler code here
  MessageBox("La ayuda no est todava a punto","Ayuda");
}

void CCannyMresDlg4x4::ExpandDialog ()
{
	// Expand the dialog to full size if bExpand is TRUE; otherwise
	// contract, with the new bottom set to the bottom of the 
	// divider control specified in IDC_DIVIDER.

	static  CRect rcLarge;
	static  CRect rcSmall;
	CString sExpand;

	// First time through, save the dialogs large
	// and small sizes
	if (rcLarge.IsRectNull())
	{
		CRect rcLandmark;
		CWnd* pWndLandmark = GetDlgItem (IDC_DIVIDER);
		ASSERT(pWndLandmark);	
	
		GetWindowRect (rcLarge);
		pWndLandmark->GetWindowRect (rcLandmark);
	
		rcSmall = rcLarge;
		rcSmall.bottom = rcLandmark.top;
	}

	if (bExpand)
	{
		// Expand the dialog: resize the dialog
		// to its original size (rcLarge)
		SetWindowPos(NULL, 0, 0, rcLarge.Width(), rcLarge.Height(),
			SWP_NOMOVE | SWP_NOZORDER);

		sExpand = "<< &Principal";
		EnableVisibleChildren();
	}
	else
	{
		// Contract the dialog to the small size
		SetWindowPos(NULL, 0, 0, rcSmall.Width(), rcSmall.Height(),
			SWP_NOMOVE | SWP_NOZORDER);

		sExpand = "  &Ajuste fino >>";
		EnableVisibleChildren();
	}	
	
	SetDlgItemText (IDC_MORE, sExpand);
}


void CCannyMresDlg4x4::EnableVisibleChildren()
{
	// Disable all children not in the current dialog. This prevents
	// tabbing to hidden controls and disables accelerators.

	// Get the first child control
	CWnd *pWndCtl = GetWindow (GW_CHILD);
	CRect rcTest;
	CRect rcControl;
	CRect rcShow;
	
	GetWindowRect(rcShow);
	   
	while (pWndCtl != NULL)
	{
		pWndCtl->GetWindowRect (rcControl);
		
		if (rcTest.IntersectRect (rcShow, rcControl))
			pWndCtl->EnableWindow(TRUE);
		else
			pWndCtl->EnableWindow(FALSE);
		
		// Get the next sibling window in this chain.
		pWndCtl = pWndCtl->GetWindow (GW_HWNDNEXT);
	}
}

void CCannyMresDlg4x4::OnMore() 
{
	// TODO: Add your control notification handler code here
	// bExpand controla el estado expandido (frente al contrado)
  ExpandDialog ();
  bExpand = !bExpand;
}


BEGIN_MESSAGE_MAP(CCannyMresDlg4x4, CDialog)
	//{{AFX_MSG_MAP(CCannyMresDlg)
 	ON_BN_CLICKED(IDC_HELP_CANY, OnHelp)
	ON_WM_HSCROLL()
	ON_WM_LBUTTONUP()
	ON_BN_CLICKED(IDC_MORE, OnMore)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/*********************************************************************************/

#include "dibdoc.h"
#include "..\miguelan\visionty.h"

/*********************************************************************************/

void CImgBasicDoc::Multires (int MultiresType)
{
 /* This funcition calls doRobGreadient24 if the image is coloured  *
   * or doRobGreadientGrey if the image is monocrome                 */

  byte *thepic=NULL;         /* Copy of the formatted original image */
  byte *results=NULL;         /* Buffer where store transformed image */
  int pfree, typePic;
  u_int NewNumCols;
  byte *rp, *gp, *bp;
  clock_t start;


  CMResDlg dlg(MultiresType);
  int ReturnValue=dlg.DoModal();

  /* Dont do nothing if exited from dialog with cancel */
  if (ReturnValue==IDCANCEL) return;

  /* Call a function depending of the color information */
  /* Get a standard greyscale/RGB version of the real image    */
  thepic = GetImage(&typePic, (mono) ? F_GREYSCALE : F_FULLCOLOR,
                    &pfree, &NewNumCols, &rp, &gp, &bp, 256);
  /* Failed to get the greyscale image     */
  if (!thepic) return;  //NULL PIC

  if ( mono ) { // MONOCHROME IMAGE

    OpenAlert("Realizando el proceso de extraccin"
     " de contornos multirresolucin\n\n"
     "Algoritmo tomado del PFC realizado por D. Miguel Angel "
     "Martnez Esteban y dirigido por Dr. Jose Ramn Beltrn Vzquez\n\n"
     "CPSUZ, mayo 1995.");

    start = clock();

    /* Call the actual algorithm for greyscale images        */ 
    switch ( MultiresType ) {
      case ALG_MULTIRES:
          results = doGaussMultiresGrey(thepic, pWIDE, pHIGH,min_level,
                                       max_level, threshold,reclasificacion,
                                       min_len, dlg.seguimiento, pasoApaso);
          break;
      case ALG_FASTMRES:
          results = doFastMultiresGrey (thepic, pWIDE, pHIGH,min_level,
                                       max_level, threshold,reclasificacion,
                                       min_len, dlg.seguimiento, pasoApaso);
          break;
      case ALG_CANYMRES:
          results = doCannyMultiresGrey(thepic, pWIDE, pHIGH,min_level,
                                       max_level, threshold,threshold/4,
                                       reclasificacion,
                                       min_len, dlg.seguimiento, pasoApaso);
          break;
    }
    
  } else {  // COLOR IMAGE

    clock_t start = clock();

    /* Call the actual algorithm for color images            */ 
    switch ( MultiresType ) {
      case ALG_MULTIRES:
          results = doGaussMultires24 (thepic, pWIDE, pHIGH, min_level,
                                       max_level, threshold,reclasificacion,
                                       min_len, dlg.seguimiento, pasoApaso);
          break;
      case ALG_FASTMRES:
          results = doFastMultires24  (thepic, pWIDE, pHIGH,min_level,
                                       max_level, threshold,reclasificacion,
                                       min_len, dlg.seguimiento, pasoApaso);
          break;
      case ALG_CANYMRES:
          results = doCannyMultires24 (thepic, pWIDE, pHIGH,min_level,
                                       max_level, threshold,threshold/4,
                                       reclasificacion,
                                       min_len, dlg.seguimiento, pasoApaso);
          break;
    }
  }
  ElapsedTime("Multires", start);

  /* free thepic if needed */
  if (pfree) free(thepic);

  if (!results) return;

  /* Store new image, allow 'undo', uptade display, etc.   */
  StoreNewPic(results,PIC8,TRUE);
  
  if ( MultiresType != ALG_CANYMRES ) {
     /* image is not really grayscaled */
     mono=FALSE;
     // Puntos gap o de rotura de contorno: naranja
     gMap[GAP]=bMap[GAP]=32;
     rMap[GAP]=128;
     // Puntos indeterminados: gris oscuro
     rMap[INDETERMINADO]=gMap[INDETERMINADO]=bMap[INDETERMINADO]=100;
     // Puntos escalera: azul claro
     rMap[ESCALERA]=gMap[ESCALERA]=128;
     bMap[ESCALERA]=255;
     // Puntos rampa: verde claro
     rMap[RAMPA]=bMap[RAMPA]=128;
     gMap[RAMPA]=255;
     // Puntos pulso: rojo intenso
     gMap[PULSO]=bMap[PULSO]=0;
     rMap[PULSO]=255;
     // Puntos escalon: color blanco (por defecto)
     gMap[PULSO]=bMap[PULSO]=rMap[PULSO]=255;
     printf(
       "CARACTERIZACIN DE PUNTOS CONTORNO\n"
       "Puntos gap o de rotura de contorno: naranja\n"
       "Puntos indeterminados: gris oscuro\n"
       "Puntos escalera: azul claro\n");
     printf(
       "Puntos rampa: verde claro\n"
       "Puntos pulso: rojo intenso\n"
       "Puntos escalon: color blanco (por defecto)\n");

  }

  CloseAlert(); // Alerta eliminada
  RedrawPic(); // Display new picture
}

/*********************************************************************************/
void CImgBasicDoc::CannyMRes (int type)
{
 /* This funcition calls doRobGreadient24 if the image is coloured  *
   * or doRobGreadientGrey if the image is monocrome                 */

  byte *thepic=NULL;         /* Copy of the formatted original image */
  byte *results=NULL;         /* Buffer where store transformed image */
  int pfree, typePic;
  u_int NewNumCols;
  byte *rp, *gp, *bp;
  clock_t start;

  int ReturnValue;
  if (type) {
    CCannyMresDlg4x4 dlg;
    ReturnValue = dlg.DoModal();
  } else {
    CCannyMresDlg dlg;
    ReturnValue = dlg.DoModal();
  }
  /* Dont do nothing if exited from dialog with cancel */
  if (ReturnValue==IDCANCEL) return;
  /* Call a function depending of the color information */
  /* Get a standard greyscale/RGB version of the real image    */
  thepic = GetImage(&typePic, (mono) ? F_GREYSCALE : F_FULLCOLOR,
                &pfree, &NewNumCols, &rp, &gp, &bp, 256);
  /* Failed to get the greyscale image     */
  if (!thepic) return;  //NULL PIC
  start = clock();


  if ( mono ) { // MONOCHROME IMAGE

    /* Call the actual algorithm for greyscale images        */ 
      results = doCannyMultiresGrey(thepic, pWIDE, pHIGH,min_level,
                                   max_level, threshold,
                                   noise_level, reclasificacion,
                                   min_len, orden, pasoApaso,
                                   desplazamiento, min_len_noise,
                                   holg_ang, (type) ? noise_comp : -1);    
  } else {  // COLOR IMAGE

    /* Call the actual algorithm for color images            */ 
    results = doCannyMultires24 (thepic, pWIDE, pHIGH,min_level,
                                   max_level, threshold,
                                   noise_level, reclasificacion,
                                   min_len, orden, pasoApaso,
                                   desplazamiento, min_len_noise,
                                   holg_ang, (type) ? noise_comp : -1);

  }

  ElapsedTime("CannyMRes", start);

  /* free thepic if needed */
  if (pfree) free(thepic);

  if (!results) return;

  /* Store new image, allow 'undo', uptade display, etc.   */
  StoreNewPic(results,PIC8,TRUE);  

  RedrawPic(); //Display new image
} //End of CannyMRes

//////////////////////////////////////////////////////////////////////

