// MultiFileDialog.cpp : implementation file
// Scott


#include "stdafx.h"
#include "MultiFil.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MAXMULTIPATH 2048

// determine number of elements in an array (not bytes) (taken from AFXIMPL.H)
#define _countof(array) (sizeof(array)/sizeof(array[0]))


/////////////////////////////////////////////////////////////////////////////
// CMultiFileDialog

IMPLEMENT_DYNAMIC(CMultiFileDialog, CFileDialog)

CMultiFileDialog::CMultiFileDialog(BOOL bOpenFileDialog, LPCTSTR lpszDefExt, LPCTSTR lpszFileName,
		DWORD dwFlags, LPCTSTR lpszFilter, CWnd* pParentWnd) :
		CFileDialog(bOpenFileDialog, lpszDefExt, lpszFileName, dwFlags, lpszFilter, pParentWnd)
{
	m_pszFileName = new TCHAR[MAXMULTIPATH];
	// new automatically throws a memory exception if it fails
	m_pszFileName[0] = '\0';
}


BEGIN_MESSAGE_MAP(CMultiFileDialog, CFileDialog)
	//{{AFX_MSG_MAP(CMultiFileDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CMultiFileDialog::~CMultiFileDialog()
{
	if (m_pszFileName != NULL)
		delete [] m_pszFileName;
}

int CMultiFileDialog::DoModal()
{
	ASSERT_VALID(this);
	ASSERT(m_ofn.Flags & OFN_ALLOWMULTISELECT);

	m_ofn.lpstrFile = m_pszFileName;
	m_ofn.nMaxFile = MAXMULTIPATH;

	return CFileDialog::DoModal();
}
