#ifndef _MULTIPAD_H_
#define _MULTIPAD_H_

// multipad.h : main header file for the Multipad application
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1995 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.


#include <afxext.h>
#include "..\res\resource.h"


int print(const char *format, ...);
int scan(const char *format, ...);


class CPadView : public CEditView
{
	DECLARE_DYNCREATE(CPadView)
protected:
  BOOL m_bScanning;
  BOOL m_bReadOnly;
  int  m_ScanChar;
public:
  CPadView();
  ~CPadView();
  BOOL IsScanning() const {return m_bScanning;};
  void StopScanning();
  int vprintf(const char *format,  va_list argptr);
  int vscanf (const char *format,  va_list argptr);
  //{{AFX_MSG(CPadView)
    afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
    afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
    afx_msg void OnMaxtExt();
    afx_msg void OnErrSpace();
	//}}AFX_MSG
  DECLARE_MESSAGE_MAP()
};

class CPadDoc : public CDocument
{
	DECLARE_DYNCREATE(CPadDoc)
public:
  void Serialize(CArchive& ar);
  CPadView* GetView();
  // Overridables
  virtual BOOL CanCloseFrame( CFrameWnd* pFrame );

  //{{AFX_MSG(CPadDoc)
    afx_msg void OnDeletecontents();
	//}}AFX_MSG
  /*
  */
  DECLARE_MESSAGE_MAP()
};

#endif _MULTIPAD_H_
/////////////////////////////////////////////////////////////////////////////
// CPadFrame frame

class CPadFrame : public CMDIChildWnd
{
	DECLARE_DYNCREATE(CPadFrame)
protected:
	CPadFrame();           // protected constructor used by dynamic creation

// Menu Data
protected: // menu to give to the the MDI Frame
	static CMenu m_menu;     // menu for all Inspection windows

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPadFrame)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle = WS_CHILD | WS_VISIBLE | WS_OVERLAPPEDWINDOW, const RECT& rect = rectDefault, CMDIFrameWnd* pParentWnd = NULL, CCreateContext* pContext = NULL);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CPadFrame();

	// Generated message map functions
	//{{AFX_MSG(CPadFrame)
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
